package dev.flyfish.framework.bean;

import org.springframework.data.domain.Page;

/**
 * 分页实体的bean
 *
 * @param <T> 泛型
 */
public class PageBean<T> {

    private Integer page;

    private Long totalCount;

    private Integer totalPages;

    private Integer size;

    public PageBean(Page<T> page) {
        // 页大小
        this.size = page.getSize();
        // 页码
        this.page = page.getNumber() + 1;
        this.totalCount = page.getTotalElements();
        this.totalPages = page.getTotalPages();
    }

    public Integer getPage() {
        return page;
    }

    public void setPage(Integer page) {
        this.page = page;
    }

    public Long getTotalCount() {
        return totalCount;
    }

    public void setTotalCount(Long totalCount) {
        this.totalCount = totalCount;
    }

    public Integer getTotalPages() {
        return totalPages;
    }

    public void setTotalPages(Integer totalPages) {
        this.totalPages = totalPages;
    }

    public Integer getSize() {
        return size;
    }

    public void setSize(Integer size) {
        this.size = size;
    }
}
