package dev.flyfish.framework.validation.annotations;

import dev.flyfish.framework.validation.validators.IdCardValidator;

import jakarta.validation.Constraint;
import jakarta.validation.Payload;
import dev.flyfish.framework.validation.annotations.IdCard.List;

import java.lang.annotation.Documented;
import java.lang.annotation.Repeatable;
import java.lang.annotation.Retention;
import java.lang.annotation.Target;

import static java.lang.annotation.ElementType.*;
import static java.lang.annotation.ElementType.ANNOTATION_TYPE;
import static java.lang.annotation.RetentionPolicy.RUNTIME;

@Target({METHOD, FIELD, ANNOTATION_TYPE, CONSTRUCTOR, PARAMETER})
@Retention(RUNTIME)
@Documented
@Constraint(validatedBy = {IdCardValidator.class})
@Repeatable(List.class)
public @interface IdCard {

    String message() default "不是合法的身份证号！";

    //分组
    Class<?>[] groups() default {};

    //负载
    Class<? extends Payload>[] payload() default {};

    //指定多个时使用
    @Target({FIELD, METHOD, PARAMETER, ANNOTATION_TYPE})
    @Retention(RUNTIME)
    @Documented
    @interface List {
        IdCard[] value();
    }
}
