package dev.flyfish.framework.validation.annotations;

import dev.flyfish.framework.validation.annotations.UniqueField.List;
import dev.flyfish.framework.validation.validators.UniqueFieldValidator;

import jakarta.validation.Constraint;
import jakarta.validation.Payload;
import java.lang.annotation.Documented;
import java.lang.annotation.Repeatable;
import java.lang.annotation.Retention;
import java.lang.annotation.Target;

import static java.lang.annotation.ElementType.*;
import static java.lang.annotation.RetentionPolicy.RUNTIME;

@Target({METHOD, FIELD, ANNOTATION_TYPE, CONSTRUCTOR, PARAMETER})
@Retention(RUNTIME)
@Documented
@Constraint(validatedBy = {UniqueFieldValidator.class})
@Repeatable(List.class)
public @interface UniqueField {

    String message() default "集合中的关键字段不唯一！";

    // 唯一字段
    String value() default "";

    //分组
    Class<?>[] groups() default {};

    //负载
    Class<? extends Payload>[] payload() default {};

    //指定多个时使用
    @Target({FIELD, METHOD, PARAMETER, ANNOTATION_TYPE})
    @Retention(RUNTIME)
    @Documented
    @interface List {
        UniqueField[] value();
    }
}
