package dev.flyfish.framework.validation.validators;

import dev.flyfish.framework.validation.annotations.Money;

import jakarta.validation.ConstraintValidator;
import jakarta.validation.ConstraintValidatorContext;

/**
 * 金额验证器
 * @author wangyu
 */
public class MoneyValidator implements ConstraintValidator<Money, Long> {

    /**
     * Implements the validation logic.
     * The state of {@code value} must not be altered.
     * <p>
     * This method can be accessed concurrently, thread-safety must be ensured
     * by the implementation.
     *
     * @param value   object to validate
     * @param context context in which the constraint is evaluated
     * @return {@code false} if {@code value} does not pass the constraint
     */
    @Override
    public boolean isValid(Long value, ConstraintValidatorContext context) {
        return null == value || value >= 9;
    }
}
