package dev.flyfish.framework.domain.po;

import dev.flyfish.framework.annotations.Entity;
import dev.flyfish.framework.annotations.Property;
import dev.flyfish.framework.domain.tree.TreeDomain;
import lombok.*;

/**
 * 部门
 *
 * @author wangyu
 */
@Entity(table = "t_department", collection = "departments")
@Getter
@Setter
@NoArgsConstructor
@AllArgsConstructor
@Builder
public class Department extends TreeDomain<Department> {

    public static final String PUBLIC = "public";

    /**
     * 部门的完整名称
     */
    @Property(column = "full_name")
    private String fullName;

    /**
     * 默认选中
     */
    private Boolean primary;

    /**
     * 负责人
     */
    private String manager;

    /**
     * 联系电话
     */
    private String phone;

    /**
     * 地址
     */
    private String address;

    /**
     * 是否是部门（叶子节点）
     */
    private Boolean leaf;

    /**
     * 排序字段
     */
    private Integer pos;
}
