package dev.flyfish.framework.generation;

import dev.flyfish.framework.domain.base.Domain;
import reactor.core.publisher.Mono;

/**
 * 代码规则策略
 *
 * @author wangyu
 */
public interface CodeRuleStrategy {

    /**
     * 生成代码
     *
     * @param domain 实体
     * @return 结果
     */
    String generate(Domain domain);

    /**
     * 异步方式，支持异步请求
     *
     * @param domain 实体
     * @return 结果
     */
    default Mono<String> retrieve(Domain domain) {
        return Mono.just(generate(domain));
    }
}
