package dev.flyfish.framework.r2dbc.repository;

import dev.flyfish.framework.r2dbc.domain.TestDO;
import dev.flyfish.framework.r2dbc.domain.TestDTO;
import dev.flyfish.framework.r2dbc.domain.reference.TestChild;
import dev.flyfish.framework.repository.DefaultReactiveRepository;
import reactor.core.publisher.Mono;

import static group.flyfish.fluent.chain.SQL.select;
import static group.flyfish.fluent.query.Query.where;

/**
 * 测试仓库
 */
public interface TestRepository extends DefaultReactiveRepository<TestDO> {

    Mono<TestDO> findByNameContaining(String like);

    default Mono<TestDTO> getDTOById(Long id) {
        return select().from(TestDO.class)
                .leftJoin(TestChild.class).on(where(TestDO::getId).eq(TestChild::getParentId))
                .matching(where(TestDO::getId).eq(id))
                .as(TestDTO.class)
                .reactive()
                .one();
    }
}
