CREATE TABLE IF NOT EXISTS `t_dictionary`
(
    `id`          VARCHAR(36)  NOT NULL COMMENT '主键',
    `code`        VARCHAR(32)  NOT NULL COMMENT '编码',
    `name`        VARCHAR(100) NOT NULL COMMENT '名称',
    `values`      JSON         NULL COMMENT '字典值列表',
    `description` VARCHAR(500) NULL COMMENT '字典描述',
    `create_time` DATETIME     NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
    `modify_time` DATETIME     NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '修改时间',
    `creator`     VARCHAR(36)  NULL COMMENT '创建人名称',
    `creator_id`  VARCHAR(36)  NULL COMMENT '创建人id',
    `modifier`    VARCHAR(36)  NULL COMMENT '修改人名称',
    `modifier_id` VARCHAR(36)  NULL COMMENT '修改人id',
    `delete`      BIT(1)       NOT NULL DEFAULT b'0',
    PRIMARY KEY (`id`)
) COMMENT '字典定义表';

CREATE TABLE IF NOT EXISTS `t_auto_complete`
(
    `id`          VARCHAR(36)  NOT NULL COMMENT '主键',
    `code`        VARCHAR(32)  NOT NULL COMMENT '编码',
    `name`        VARCHAR(100) NOT NULL COMMENT '名称',
    `values`      JSON         NULL COMMENT '候选值列表',
    `cascade`     BIT(1)       NULL COMMENT '是否多级联动',
    `description` VARCHAR(500) NULL COMMENT '描述',
    `delimiter`   VARCHAR(10)  NULL COMMENT '分隔符',
    `create_time` DATETIME     NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
    `modify_time` DATETIME     NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '修改时间',
    `creator`     VARCHAR(36)  NULL COMMENT '创建人名称',
    `creator_id`  VARCHAR(36)  NULL COMMENT '创建人id',
    `modifier`    VARCHAR(36)  NULL COMMENT '修改人名称',
    `modifier_id` VARCHAR(36)  NULL COMMENT '修改人id',
    `delete`      BIT(1)       NOT NULL DEFAULT b'0',
    PRIMARY KEY (`id`)
) COMMENT '自动完成数据源';
