package dev.flyfish.framework.user.config.captcha;

import com.anji.captcha.model.common.ResponseModel;
import com.anji.captcha.model.vo.CaptchaVO;
import com.anji.captcha.service.CaptchaService;
import dev.flyfish.framework.user.config.properties.SecurityProperties;
import dev.flyfish.framework.utils.Assert;
import lombok.RequiredArgsConstructor;

@RequiredArgsConstructor
public class AnjiCaptchaValidator implements CaptchaValidator {

    private final SecurityProperties securityProperties;

    private final CaptchaService captchaService;

    /**
     * 进行验证，并抛出异常
     *
     * @param token 验证码认证token
     */
    @Override
    public void verify(String token) {
        // 未启用，不拦截
        if (!securityProperties.getCaptcha().isEnable()) {
            return;
        }
        // 进行验证
        CaptchaVO captchaVO = new CaptchaVO();
        captchaVO.setCaptchaVerification(token);
        ResponseModel response = captchaService.verification(captchaVO);
        Assert.isTrue(response.isSuccess(), "请完成滑动验证！");
    }
}
